MSCZJOBU	;RHL,JDS,JKT/MSC;26JUN2009
	;;8.0;KERNEL;**MSC**
	;
	;  JOB EXAM UTILITIES FOR GT.M
	Q
PIDS(XARY)	; GET ARRAY OF ALL MUMPS PROCESS
	;  XARY PASSED BY REFERENCE
	;  RETURNS XARY(PID)=""
	;  NOTE:  Unix PID=$J for all mumps processes.
	;
	N DEV
	S DEV="psdev"
	OPEN DEV:(COMM="ps -o pid= -C mumps":READONLY)::"PIPE" U DEV
	;
	N %I S %I=$I
	N %J ; $JOB
	F  U DEV R %J U %I Q:%J=""  D
	. F  Q:$E(%J,1)'=" "  S %J=$E(%J,2,999) ; strip leading spaces
	. S XARY(%J)=""
	;
	C DEV
	Q
	;
JOBEXAM(XARY,ONEPID)	; GET ARRAY OF JOB EXAM DATA FOR ALL MUMPS PROCESSES
	;  XARY is the name of a variable (or global) to merge job exam data into
	;
	; get a list of all OpenVista instances and look up their $ZG values
	N Y D LIST^ZCD
	N INSTANCE S INSTANCE=""
	F  S INSTANCE=$O(Y("B",INSTANCE)) Q:INSTANCE=""  D
	. N %ZG,%ZRO D NEWZGZRO^ZCD(INSTANCE)
	. S Y("B",INSTANCE)=%ZG
	;
	I $G(ONEPID) D GETJOB(ONEPID) Q
	; for each mumps process, search each OpenVista instance for the latest job exam data
	D PIDS(.XARY) ; XARY is doing double-duty; here it's an array
	N PID S PID=""
	F  S PID=$O(XARY(PID)) Q:PID=""  D GETJOB(PID)
	Q
GETJOB(PID)	;
	N SORTDATE
	F  S INSTANCE=$O(Y("B",INSTANCE)) Q:INSTANCE=""  D
	. N H S H=$G(^|Y("B",INSTANCE)|TMP("MSCZJOB",PID,0)) Q:H=""
	. S SORTDATE($$SEC^XLFDT(H))=INSTANCE
	N MAXDATE S MAXDATE=$O(SORTDATE(""),-1) Q:MAXDATE=""
	M @XARY@(PID)=^|Y("B",SORTDATE(MAXDATE))|TMP("MSCZJOB",PID)
	Q
	;
OWNER(PID)	; get owner of process with PID
	N DEV
	S DEV="psdev"
	OPEN DEV:(COMM="ps -o user= -p "_PID:READONLY)::"PIPE" U DEV
	N UID R UID
	C DEV
	Q UID
	;
INTRPT(PID)	; SEND mupip intrpt to process with PID
	;  WHICH CAUSES THE $ZINTERRUPT CODE TO BE EXECUTED.
	;  PID PASSED BY VALUE
	;  PID CAN BE A SINGLE PID, I.E. $J
	;  PID CAN BE A "*" WHICH SENDS AN INTERRUPT TO ALL MUMPS PROCESSES
	;
	Q:$G(PID)'?1N.N&($G(PID)'="*")
	;
	N CMD,DEV
	S CMD="gtmsignal -q "_$S(PID="*":"-a",1:PID)
	S DEV="gtmsignaldev"
	OPEN DEV:(COMM=CMD:READONLY)::"PIPE" U DEV C DEV
	Q
	;
KILL(PID)	; Send mupip stop to process with PID
	;  PID PASSED BY VALUE
	;  PID CAN BE A SINGLE PID, I.E. $J
	;
	Q:$G(PID)'?1N.N
	;
	N DEV
	S DEV="gtmsignaldev"
	OPEN DEV:(COMM="gtmsignal -q -s "_PID:READONLY)::"PIPE" U DEV C DEV
	Q
	;
UNLOCK(NODE,INSTANCE)	; Use lke to remove lock on NODE.
	N %ZG,%ZRO
	D:$G(INSTANCE)'="" NEWZGZRO^ZCD(INSTANCE)
	N CMD,DEV
	S CMD="lke clear -lock="""_NODE_""" -nointeractive -output=/dev/null"
	S:$G(%ZG)'="" CMD="gtmgbldir="""_%ZG_""" "_CMD
	S DEV="lkedev"
	OPEN DEV:(SHELL="/bin/sh":COMM=CMD:READONLY)::"PIPE" U DEV C DEV
	Q
